= nng_http_server_res_error(3http)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_http_server_res_error - use HTTP server error page

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>
#include <nng/supplemental/http/http.h>

int nng_http_server_res_error(nng_http_server *server, 
        nng_http_res *response);
----

== DESCRIPTION

The `nng_http_server_res_error()` sets the body of _response_
to _server_'s error page, which may have been customized using the
xref:nng_http_server_set_error_file.3http.adoc[`nng_http_server_error_file()`]
or
xref:nng_http_server_set_error_page.3http.adoc[`nng_http_server_error_page()`]
functions.

The status code of the _response_ should have already been set, either
implicitly by allocating it with
xref:nng_http_res_alloc_error.3http.adoc[`nng_http_res_alloc_error()`],
or by calling
xref:nng_http_res_set_status.3http.adoc[`nng_http_res_set_status()`].

Any content body previously set for _response_ will be overridden by
this function.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient free memory exists.
`NNG_ENOTSUP`:: HTTP not supported.

== SEE ALSO

[.text-left]
xref:nng_http_res_alloc_error.3http.adoc[nng_http_res_alloc_error(3http)],
xref:nng_http_server_hold.3http.adoc[nng_http_server_hold(3http)],
xref:nng_http_server_set_error_file.3http.adoc[nng_http_server_set_error_file(3http)],
xref:nng_http_server_set_error_page.3http.adoc[nng_http_server_set_error_page(3http)],
xref:nng_strerror.3.adoc[nng_strerror(3)],
xref:nng.7.adoc[nng(7)]
